
/* Copyright (c) 2012 by Al Williams

Permission is hereby granted, free of charge, to any person obtaining a copy of this software
and associated documentation files (the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial
portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

This software is intended to communicate with a GP9 device. Note that the above license covers,
However, this software does not include the firmware that resides inside the GP9. The above license
covers THIS software and not the GP9 firmware, which is not included in this distribution.

More info: http://www.awce.com/gp9.htm
al.williams@awce.com

*/
#ifndef GP9_H
#define GP9_H
#include <QString>

class gp9
{
public:
    gp9(QString _port) { portopen=error=false; port=_port; }  // create with given port (ttyUSB1, COM2, etc.)
     bool open();    // open it up
     bool isOpen();  // determine if open
     bool close();   // close down
     void setpwm(int chan, int pwm);  // set PWM from 0 to 255 on channel 0-7. (Source must be set)
     void setsource(int mask);    // source bits for channel 0-7, 1=slider, 0=analog input
     void setjam(int mask);       // jam channels 0-7 high by setting the corresponding jam bit
     void setoe(int mask);        // output enable for channel 0-7 (0=enabled)
     int readpwm(int chan);       // read back the PWM
     int readad(int chan);        // read analog channel (0-4)
// ought to be protected but since we don't wrap everything they stay public
// so you can manually read/write to the board
     void write(int byte);   // single byte from 00-7F
     void write(int b1,int b2);  // two bytes sent in GP3/GP9 protocol
     int read(void);      // read back a byte
     int getoe(void);     // read back the OE bits
     int getsource(void);  // read back the source bits
     bool error;         // set if error detected

protected:
    QString port;    // port to use
    bool portopen;   // are we open

};

#endif // GP9_H
